package IConfig;

$VIRSION = '1.21';

#===============================================================================
# CONSTRUCTOR
#		$obj = new IConfig($config_init_file);
#===============================================================================
sub new
{
	my($pkg) = shift;
	my($cfginit) = shift;
	my($self) = {};
	bless $self, $pkg;

	# config init file
	$self->{'cfginit'} = $cfginit;

	# will not parse content by default
	$self->{'cfgparse'} = 0;

	# quote values in formelements by (default is auto detect)
	$self->{'quote'} = '';
	$self->{'config'} = {};

	return $self;
}

#===============================================================================
#	load indicated config file
#		$obj->LoadConfig();
#===============================================================================
sub LoadConfig
{
	my($self) = shift;
	my ($section,$subsection,$key,$value)=();
	my $cfg = {};
	my ($i,$j)=(100,100);
	local *FILE;

	# return error if file not specified
	return $self->setError(q{To init module use : $obj = new IConfig('./templates_directory/config_file.init') or $obj = new IConfig();	$obj->{'cfginit'} = './templates_directory/config_file.init';}) if ! defined $self->{'cfginit'};

	# return error if file do not exist
	return $self->setError("$! : $self->{'cfginit'}") if !-e $self->{'cfginit'};

	# open and read file. return error if we can not
	open (FILE, "$self->{'cfginit'}") || return $self->setError("$! : $self->{'cfginit'}");
	while (my $line = <FILE>)
	{
		# empty lines and comments
		next if $line =~ /^\s*$/;
		next if $line =~ /^\s*\#/;

		# sections {}
		if ($line =~ /^\s*\{.*\}\s*$/)
		{
			++$i;
			$section=$line;
			$section=~s/^\s*\{//;
			$section=~s/\}\s*$//;
			$section=~s/^\s+//;
			$section=~s/\s+$//;
			$cfg{"<!--$i-->$section"}={};
			next;
		}

		# subsections []
		if ($line =~ /^\s*\[.*\]\s*$/)
		{
			++$j;
			$subsection=$line;
			$subsection=~s/^\s*\[//;
			$subsection=~s/\]\s*$//;
			$subsection=~s/^\s+//;
			$subsection=~s/\s+$//;
			$cfg{"<!--$i-->$section"}{"<!--$j-->$subsection"}={};
			next;
		}

		# keys and values
		($key,$value) = split /\=/,$line,2;
		$key=~s/^\s+//;$key=~s/\s+$//;
		$value=~s/^\s+//;$value=~s/\s+$//;
		$cfg{"<!--$i-->$section"}{"<!--$j-->$subsection"}{$key} = $value;
	}
	close(FILE);

	# enumerate through section-subsections
	foreach $section(keys %cfg)	{ foreach $subsection(keys %{$cfg{$section}})
	{
		my $type = $cfg{$section}{$subsection}{'type'}; delete $cfg{$section}{$subsection}{'type'};
		my $name = $cfg{$section}{$subsection}{'name'}; delete $cfg{$section}{$subsection}{'name'};
		my $value = $cfg{$section}{$subsection}{'value'}; delete $cfg{$section}{$subsection}{'value'};
		my $attr = $cfg{$section}{$subsection}{'attr'}; delete $cfg{$section}{$subsection}{'attr'};
		my $text = $cfg{$section}{$subsection}{'text'}; delete $cfg{$section}{$subsection}{'text'};
		my $quote = $cfg{$section}{$subsection}{'quote'}; delete $cfg{$section}{$subsection}{'quote'};
		my $vquote = $cfg{$section}{$subsection}{'vquote'}; delete $cfg{$section}{$subsection}{'vquote'};
		my $var = $cfg{$section}{$subsection}{'var'}; delete $cfg{$section}{$subsection}{'var'};

		# eval value if vexec
		if ($cfg{$section}{$subsection}{'vexec'})
		{
			eval($cfg{$section}{$subsection}{'vexec'});
			$@?($value = $@):($value=$_);
			delete $cfg{$section}{$subsection}{'vexec'};
			undef $_;
		};

		# eval value if texec
		if ($cfg{$section}{$subsection}{'texec'})
		{
			eval($cfg{$section}{$subsection}{'texec'});
			$@?($text = $@):($text=$_);
			delete $cfg{$section}{$subsection}{'texec'};
			undef $_;
		};
		
		# variable by default
		$var = '$' if !$var;
		
		# value for variable or array or hash
		my $vl = ();
		if ($var eq '$') { eval('$vl = $main::'.$name) }
		elsif ($var eq '@') { eval('$vl = join (" ", @main::'.$name.")") }
		elsif ($var eq '%') { foreach (eval('keys %main::'.$name)) { $vl .= "$_ ".eval('$main::'.$name."{$_}")."\n"} }
		
		# quote formelements values by
		if (!$vquote and $self->{'quote'}) { $vquote = $self->{'quote'} }
		elsif (!$vquote and !$self->{'quote'} and !$self->{'cfgparse'}) { ($value=~/"/g)?($vquote='\''):($vquote='"') }
		elsif (!$vquote and !$self->{'quote'} and $self->{'cfgparse'}) { ($vl=~/"/g)?($vquote='\''):($vquote='"') }
		
		# form fields
		if (lc($type) =~ 'text"*$' or lc($type) =~ 'password')
		{
			$value = $vl if $self->{'cfgparse'} and eval('defined '.$var.'main::'.$name);
			$value = &HTMLFormating($value);
			$cfg{$section}{$subsection}{'formelement'} = qq{<input type="$type" name="$name" value=$vquote$value$vquote $attr>}
		}
		elsif (lc($type) =~ 'textarea')
		{
			$value = $vl if $self->{'cfgparse'} and eval('defined '.$var.'main::'.$name);
			$value = &HTMLFormating($value);
			$value =~ s!\\n!\n!g;
			$cfg{$section}{$subsection}{'formelement'} = qq{<textarea name=$name $attr>$value</textarea>};
		}
		elsif (lc($type) =~ 'radio')
		{
			my @text=split(/\;/, $text); my $i=-1;
			foreach my $v(split(/\;/, $value))
			{
				$v=~s/^\s+//;$v=~s/\s+$//;++$i;
				$text[$i]=~s/^\s+//;$text[$i]=~s/\s+$//;
				if ($self->{'cfgparse'} and eval('defined $main::'.$name)) { $v=~s/^<(.*)>$/$1/; $v="$vquote".&HTMLFormating($v)."$vquote checked" if $v eq eval('$main::'.$name)}
				elsif ($v=~s/^<(.*)>$/$1/) { $v="$vquote".&HTMLFormating($v)."$vquote checked" }
				else { $v="$vquote".&HTMLFormating($v)."$vquote" }
				$cfg{$section}{$subsection}{'formelement'} .= qq{<input type="$type" name="$name" value=$v $attr>&nbsp;$text[$i]}
			}
		}
		elsif (lc($type) =~ 'checkbox')
		{
			my @text=split(/\;/, $text); my @name=split(/\;/, $name); my $i=-1;
			foreach my $v(split(/\;/, $value))
			{
				$v=~s/^\s+//;$v=~s/\s+$//;++$i;
				$text[$i]=~s/^\s+//;$text[$i]=~s/\s+$//;
				$name[$i]=~s/^\s+//;$name[$i]=~s/\s+$//;
				my $checked = '';
				if ($self->{'cfgparse'} and eval('defined $main::'.$name[$i])) { $v=~s/^<(.*)>$/$1/; $checked='checked' if grep ($v eq $_, split(/\,/, eval('$main::'.$name[$i]))) }
				elsif ($v=~s/^<(.*)>$/$1/) { $checked='checked' }
				$v="$vquote".&HTMLFormating($v)."$vquote $checked";
				$cfg{$section}{$subsection}{'formelement'} .= qq{<input type="$type" name="$name[$i]" value=$v $attr>&nbsp;$text[$i]}
			}
		}
		elsif (lc($type) =~ 'select')
		{
			my @text=split(/\;/, $text); my $i=-1;
			$cfg{$section}{$subsection}{'formelement'} .= qq{<select name=$name $attr>};
			foreach my $v(split(/\;/, $value))
			{
				$v=~s/^\s+//;$v=~s/\s+$//;++$i;
				$text[$i]=~s/^\s+//;$text[$i]=~s/\s+$//;
				my $selected = '';
				if ($self->{'cfgparse'} and eval('defined $main::'.$name)) { $v=~s/^<(.*)>$/$1/; $selected='selected' if $v eq eval('$main::'.$name)}
				elsif ($v=~s/^<(.*)>$/$1/) { $selected='selected' }
				$v="$vquote".&HTMLFormating($v)."$vquote $selected";
				$cfg{$section}{$subsection}{'formelement'} .= qq{<option value=$v>$text[$i]}
			}
			$cfg{$section}{$subsection}{'formelement'} .= qq{</select>};
		}

		# hidden field icfg_quote_$pname for value quotation and icfg_var_$pname
		foreach (split(';', $name))
		{
			$cfg{$section}{$subsection}{'formelement'} .= qq{<input type="hidden" name="icfg_quote_$_" value="$quote">} if defined $quote;
			$cfg{$section}{$subsection}{'formelement'} .= qq{<input type="hidden" name="icfg_var_$_" value="$var">} if defined $var;
		}
		
	}};
	# / enumerate through section-subsections
	$self->{'config'} = \%cfg;
	return 0;
}

#===============================================================================
# set errorstring in $self->{'error'} and return -1
#		$obj->setError($errormessage);
#===============================================================================
sub setError
{
	my($self)     = shift;
	my($errorMsg) = shift;
	$self->{'error'} = $errorMsg if $errorMsg !~ /^\s*$/;
	return -1;
}
sub HTMLFormating
{
	my ($content) = @_;
	$content =~ s/\&/&#38;/g;
	$content =~ s/\</&#60;/g;
	$content =~ s/\>/&#62;/g;
	$content =~ s/\[/&#91;/g;
	$content =~ s/\]/&#93;/g;
	$content =~ s/\%/&#37;/g;
	$content =~ s/\"/&#34;/g;
	$content =~ s/\'/&#39;/g;
	$content =~ s/\,/&#44;/g;
	return $content;
}

1;

